Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/phys_output_write_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/phys_output_write_mod.F90	(revision 4482)
@@ -25,5 +25,5 @@
 
     USE dimphy, ONLY: klon, klev, klevp1
-    USE infotrac_phy, ONLY: nbtr, nqtot, nqo, types_trac, tracers, niso, ntiso
+    USE infotrac_phy, ONLY: nbtr, nqtot, nqo, type_trac, tracers, niso, ntiso
     USE strings_mod,  ONLY: maxlen
     USE mod_phys_lmdz_para, ONLY: is_north_pole_phy,is_south_pole_phy
@@ -271,5 +271,5 @@
         xtrain_con, xtsnow_con, xtrain_fall, xtsnow_fall, &
 #endif
-         dt_ns, delta_sst
+         dt_ns, delta_sst, dter, dser
 
     USE phys_local_var_mod, ONLY: zxfluxlat, slp, ptstar, pt0, zxtsol, zt2m, &
@@ -390,5 +390,5 @@
          alt_tropo, &
 !Ionela
-         ok_4xCO2atm, dter, dser, tkt, tks, taur, sss
+         ok_4xCO2atm, tkt, tks, taur, sss
 
     USE ocean_slab_mod, ONLY: nslay, tslab, slab_bilg, tice, seaice, &
@@ -481,4 +481,5 @@
 #ifdef CPP_StratAer 
     LOGICAL, PARAMETER :: debug_strataer=.FALSE.
+    CHARACTER(LEN=maxlen) :: unt
 #endif
     REAL,DIMENSION(klon,klev) :: z, dz
@@ -942,5 +943,5 @@
        CALL histwrite_phy(o_SWupTOAclr, zx_tmp_fi2d)
 
-       IF (ALL(types_trac/='inca') .OR. config_inca=='aeNP') THEN 
+       IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
           IF (vars_defined) THEN
              zx_tmp_fi2d(:) = swupc0(:,klevp1)*swradcorr(:)
@@ -1014,5 +1015,5 @@
        CALL histwrite_phy(o_SWupSFCclr, zx_tmp_fi2d)
 
-       IF (ALL(types_trac/='inca') .OR. config_inca=='aeNP') THEN 
+       IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
           IF (vars_defined) THEN
              zx_tmp_fi2d(:) = swupc0(:,1)*swradcorr(:)
@@ -1031,5 +1032,5 @@
        CALL histwrite_phy(o_SWdnSFCclr, zx_tmp_fi2d)
 
-       IF (ALL(types_trac/='inca') .OR. config_inca=='aeNP') THEN 
+       IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
           IF (vars_defined) THEN
              zx_tmp_fi2d(:) = swdnc0(:,1)*swradcorr(:)
@@ -1053,5 +1054,5 @@
        CALL histwrite_phy(o_LWdnSFCclr, sollwdownclr)
 
-       IF (ALL(types_trac/='inca') .OR. config_inca=='aeNP') THEN 
+       IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
           IF (vars_defined) THEN
              zx_tmp_fi2d(:) = lwupc0(:,klevp1)
@@ -1060,5 +1061,5 @@
        ENDIF
 
-       IF (ALL(types_trac/='inca') .OR. config_inca=='aeNP') THEN 
+       IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
           IF (vars_defined) THEN
              zx_tmp_fi2d(:) = -1.*lwdnc0(:,1)
@@ -1570,5 +1571,5 @@
 #ifndef CPP_ECRAD
        IF (flag_aerosol.GT.0) THEN
-          IF (ALL(types_trac/='inca') .OR. config_inca=='aeNP') THEN 
+          IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
 
              CALL histwrite_phy(o_od443aer, od443aer)
@@ -1634,5 +1635,5 @@
 
 #ifdef CPP_StratAer
-       IF (ANY(types_trac=='coag')) THEN
+       IF (type_trac=='coag') THEN
           CALL histwrite_phy(o_R2SO4, R2SO4)
           CALL histwrite_phy(o_OCS_lifetime, OCS_lifetime)
@@ -1693,5 +1694,5 @@
           CALL histwrite_phy(o_solswad0, zx_tmp_fi2d)
           
-          IF (ALL(types_trac/='inca') .OR. config_inca=='aeNP') THEN 
+          IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
 
              CALL histwrite_phy(o_toplwad, toplwad_aero)
@@ -1770,5 +1771,5 @@
        ! Champs 3D:
        IF (ok_ade .OR. ok_aie) then
-          IF (ALL(types_trac/='inca') .OR. config_inca=='aeNP') THEN 
+          IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
              CALL histwrite_phy(o_ec550aer, ec550aer)
           ENDIF
@@ -2231,5 +2232,5 @@
        CALL histwrite_phy(o_rsucs, zx_tmp_fi3d1)
 
-       IF (ALL(types_trac/='inca') .OR. config_inca=='aeNP') THEN 
+       IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
           IF (vars_defined) THEN
              DO k=1, klevp1
@@ -2247,5 +2248,5 @@
        CALL histwrite_phy(o_rsdcs, zx_tmp_fi3d1)
 
-       IF (ALL(types_trac/='inca') .OR. config_inca=='aeNP') THEN 
+       IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
           IF (vars_defined) THEN
              DO k=1, klevp1
@@ -2493,5 +2494,5 @@
        IF (iflag_phytrac == 1 ) then
 !
-         IF (ANY(types_trac == 'co2i')) THEN
+         IF (type_trac == 'co2i') THEN
            itr = 0
            DO iq = 1, nqtot
@@ -2522,5 +2523,5 @@
            CALL histwrite_phy(o_flx_co2_bb,    fco2_bb)
 
-         ELSE IF (ANY(types_trac == 'inco')) THEN
+         ELSE IF (type_trac == 'inco') THEN
            itr = 0
            DO iq = 1, nqtot
@@ -2551,5 +2552,5 @@
            CALL histwrite_phy(o_flx_co2_bb,    fco2_bb)
 
-         ELSE IF ((ANY(types_trac=='lmdz') .OR. ANY(types_trac=='coag')) .AND. ALL(types_trac /= 'inca')) THEN
+         ELSE IF (ANY(type_trac==['lmdz','coag'])) THEN
            itr = 0
            DO iq = 1, nqtot
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/phys_state_var_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/phys_state_var_mod.F90	(revision 4482)
@@ -489,5 +489,16 @@
       ! Ocean-air interface salinity minus bulk salinity, in ppt
       
-      !$OMP THREADPRIVATE(delta_sal, ds_ns, dt_ns, delta_sst)
+      REAL, ALLOCATABLE, SAVE:: dter(:) ! (klon)
+      ! Temperature variation in the diffusive microlayer, that is
+      ! ocean-air interface temperature minus subskin temperature. In K.
+
+      REAL, SAVE, ALLOCATABLE:: dser(:) ! (klon)
+      ! Salinity variation in the diffusive microlayer, that is
+      ! ocean-air interface salinity minus subskin salinity. In ppt.
+
+      real, SAVE, ALLOCATABLE:: dt_ds(:) ! (klon)
+      ! (tks / tkt) * dTer, in K
+
+      !$OMP THREADPRIVATE(delta_sal, ds_ns, dt_ns, delta_sst, dter, dser, dt_ds)
 
     CONTAINS
@@ -503,4 +514,5 @@
 USE indice_sol_mod
 use config_ocean_skin_m, only: activate_ocean_skin
+use surface_data, only: type_ocean
 IMPLICIT NONE
 
@@ -560,4 +572,8 @@
       ALLOCATE(coefh(klon,klev+1,nbsrf+1))
       ALLOCATE(coefm(klon,klev+1,nbsrf+1))
+      ! initialize cleanly coefh,coefm
+      ! (most of the time in the code these are assumed to be on klev levels)
+      coefh(:,:,:)=0
+      coefm(:,:,:)=0
       ALLOCATE(zmax0(klon), f0(klon))
       ALLOCATE(sig1(klon,klev), w01(klon,klev))
@@ -722,6 +738,11 @@
         du_gwd_front(:,:) = 0 !ym missing init   
       ENDIF
-      if (activate_ocean_skin >= 1) ALLOCATE(delta_sal(klon), ds_ns(klon), &
-           dt_ns(klon), delta_sst(klon))
+
+      if (activate_ocean_skin >= 1) then
+         ALLOCATE(delta_sal(klon), ds_ns(klon), dt_ns(klon), delta_sst(klon), &
+              dter(klon), dser(klon))
+         if (activate_ocean_skin == 2 .and. type_ocean == "couple") &
+              allocate(dt_ds(klon))
+      end if
 
     END SUBROUTINE phys_state_var_init
@@ -733,4 +754,5 @@
 USE indice_sol_mod
 use config_ocean_skin_m, only: activate_ocean_skin
+use surface_data, only: type_ocean
 IMPLICIT NONE
 include "clesphys.h"
@@ -861,6 +883,9 @@
       DEALLOCATE(ratqs_inter)
 
-      if (activate_ocean_skin >= 1) deALLOCATE(delta_sal, ds_ns, dt_ns, &
-           delta_sst)
+      if (activate_ocean_skin >= 1) then
+         deALLOCATE(delta_sal, ds_ns, dt_ns, delta_sst, dter, dser)
+         if (activate_ocean_skin == 2 .and. type_ocean == "couple") &
+              deALLOCATE(dt_ds)
+      end if
 
 #ifdef ISO    
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/physiq_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/physiq_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/physiq_mod.F90	(revision 4482)
@@ -34,11 +34,10 @@
     USE FLOTT_GWD_rando_m, only: FLOTT_GWD_rando
     USE fonte_neige_mod, ONLY  : fonte_neige_get_vars
-    USE geometry_mod, ONLY: cell_area, latitude_deg, longitude_deg, longitude,latitude, &
-         boundslon,boundslat, dx, dy, ind_cell_glo
+    USE geometry_mod, ONLY: cell_area, latitude_deg, longitude_deg
     USE ioipsl, only: histbeg, histvert, histdef, histend, histsync, &
          histwrite, ju2ymds, ymds2ju, getin
     USE ioipsl_getin_p_mod, ONLY : getin_p
     USE indice_sol_mod
-    USE infotrac_phy, ONLY: nqtot, nbtr, nqo, tracers, types_trac, nqCO2
+    USE infotrac_phy, ONLY: nqtot, nbtr, nqo, tracers, type_trac
     USE readTracFiles_mod, ONLY: addPhase
     USE strings_mod,  ONLY: strIdx
@@ -54,4 +53,5 @@
     USE pbl_surface_mod, ONLY : pbl_surface
     USE phyaqua_mod, only: zenang_an
+    USE phyetat0_mod, only: phyetat0
     USE phystokenc_mod, ONLY: offline, phystokenc
     USE phys_cal_mod, only: year_len, mth_len, days_elapsed, jh_1jan, &
@@ -69,16 +69,20 @@
     USE regr_horiz_time_climoz_m, ONLY: regr_horiz_time_climoz
     USE regr_pr_time_av_m, only: regr_pr_time_av
-    USE surface_data,     ONLY : type_ocean, ok_veget, landice_opt
-    USE time_phylmdz_mod, only: annee_ref, current_time, day_ini, day_ref, &
-          day_step_phy, itau_phy, pdtphys, raz_date, start_time, update_time, ndays
+    USE surface_data,     ONLY : type_ocean, ok_veget
+    USE time_phylmdz_mod, only: current_time, itau_phy, pdtphys, raz_date, update_time
     USE tracinca_mod, ONLY: config_inca
     USE tropopause_m,     ONLY: dyn_tropopause
     USE ice_sursat_mod,  ONLY: flight_init, airplane
     USE vampir
-    USE VERTICAL_LAYERS_MOD, ONLY: aps,bps, ap, bp
     USE write_field_phy
+#ifdef CPP_XIOS
+    USE wxios, ONLY: g_ctx, wxios_set_context
+#endif
     USE lscp_mod, ONLY : lscp
     USE wake_ini_mod, ONLY : wake_ini
+    USE yamada_ini_mod, ONLY : yamada_ini
+    USE atke_turbulence_ini_mod, ONLY : atke_ini
     USE thermcell_ini_mod, ONLY : thermcell_ini
+    USE lscp_ini_mod, ONLY : lscp_ini
 
     !USE cmp_seri_mod
@@ -98,8 +102,16 @@
 
 
+#ifdef INCA
+    USE geometry_mod,      ONLY: longitude, latitude, boundslon, boundslat, ind_cell_glo
+    USE time_phylmdz_mod,  ONLY: ndays
+    USE infotrac_phy,      ONLY: nqCO2
+#endif
 #ifdef REPROBUS
-    USE CHEM_REP, ONLY : Init_chem_rep_xjour, &
-         d_q_rep,d_ql_rep,d_qi_rep,ptrop,ttrop, &
-         ztrop, gravit,itroprep, Z1,Z2,fac,B
+    USE chem_rep, ONLY: Init_chem_rep_xjour, d_q_rep, d_ql_rep, d_qi_rep, &
+                        ptrop, ttrop, ztrop, gravit, itroprep, Z1, Z2, fac, B
+#endif
+#if defined INCA || defined REPROBUS
+    USE time_phylmdz_mod,    ONLY: annee_ref, day_ini, day_ref, start_time
+    USE vertical_layers_mod, ONLY: aps, bps, ap, bp
 #endif
 
@@ -107,5 +119,5 @@
 #ifdef CPP_RRTM
     USE YOERAD, ONLY : NRADLP
-    USE YOESW, ONLY : RSUN
+!    USE YOESW, ONLY : RSUN
 #endif
 
@@ -117,6 +129,7 @@
 
 #ifdef CPP_XIOS
-    USE xios, ONLY: xios_update_calendar, xios_context_finalize, &
-            xios_get_field_attr, xios_field_is_active
+    USE xios, ONLY: xios_update_calendar, xios_context_finalize
+    USE xios, ONLY: xios_get_field_attr, xios_field_is_active, xios_context
+    USE xios, ONLY: xios_set_current_context
     USE wxios, ONLY: missing_val, missing_val_omp
 #endif
@@ -143,6 +156,6 @@
        d_t_ajsb,d_q_ajsb, &
        d_t_ajs,d_q_ajs,d_u_ajs,d_v_ajs, &
-       d_t_ajs_w,d_q_ajs_w, &
-       d_t_ajs_x,d_q_ajs_x, &
+!       d_t_ajs_w,d_q_ajs_w, &
+!       d_t_ajs_x,d_q_ajs_x, &
        !
        d_t_eva,d_q_eva,d_ql_eva,d_qi_eva, &
@@ -157,5 +170,5 @@
        d_ts, &
        !
-       d_t_oli,d_u_oli,d_v_oli, &
+!       d_t_oli,d_u_oli,d_v_oli, &
        d_t_oro,d_u_oro,d_v_oro, &
        d_t_oro_gw,d_u_oro_gw,d_v_oro_gw, &
@@ -276,4 +289,8 @@
        sij, &
        !
+       rneblsvol, &
+       zqsatl, zqsats, &
+       qclr, qcld, qss, qvc, rnebclr, rnebss, gamma_ss, &
+       Tcontr, qcontr, qcontr2, fcontrN, fcontrP, &
        cldemi,  &
        cldfra, cldtau, fiwc,  &
@@ -302,5 +319,4 @@
        zxsnow,snowhgt,qsnow,to_ice,sissnow,runoff,albsol3_lic
        !
-
 
     IMPLICIT NONE
@@ -515,5 +531,4 @@
     !
     !
-    INTEGER debug
     INTEGER n
     !ym      INTEGER npoints
@@ -572,5 +587,5 @@
     ! Upmost level reached by deep convection and related variable (jyg)
     !
-    INTEGER izero
+!    INTEGER izero
     INTEGER k_upper_cv
     !------------------------------------------------------------------
@@ -742,5 +757,4 @@
     REAL beta_prec_fisrt(klon,klev) ! taux de conv de l'eau cond (fisrt)
     ! RomP <<<
-    REAL          :: calday
 
     !IM cf FH pour Tiedtke 080604
@@ -796,5 +810,4 @@
     !C      EXTERNAL o3cm      ! initialiser l'ozone
     EXTERNAL orbite    ! calculer l'orbite terrestre
-    EXTERNAL phyetat0  ! lire l'etat initial de la physique
     EXTERNAL phyredem  ! ecrire l'etat de redemarrage de la physique
     EXTERNAL suphel    ! initialiser certaines constantes
@@ -817,5 +830,5 @@
     REAL dialiq(klon,klev)  ! eau liquide nuageuse
     REAL diafra(klon,klev)  ! fraction nuageuse
-    REAL cldliq(klon,klev)  ! eau liquide nuageuse
+    REAL radocond(klon,klev)  ! eau condensee nuageuse
     !
     !XXX PB 
@@ -840,7 +853,4 @@
     REAL conv_t(klon,klev) ! convergence de la temperature(K/s)
     !
-#ifdef INCA
-    REAL zxsnow_dummy(klon)
-#endif
     REAL zsav_tsol(klon)
     !
@@ -857,5 +867,5 @@
     real zqsat(klon,klev)
     !
-    INTEGER i, k, iq, j, nsrf, ll, l, itr
+    INTEGER i, k, iq, nsrf, l, itr
     !
     REAL t_coup
@@ -966,4 +976,5 @@
 
     REAL picefra(klon,klev)
+    REAL zrel_oro(klon)
     !IM cf. AM 081204 END
     !
@@ -1172,4 +1183,5 @@
 
 #ifdef INCA
+    REAL :: calday, zxsnow_dummy(klon)
     ! set de variables utilisees pour l'initialisation des valeurs provenant de INCA
     REAL, DIMENSION(klon,klev,naero_grp,nbands) :: init_tauinca
@@ -1217,5 +1229,9 @@
     phys_tstep=NINT(pdtphys)
 #ifdef CPP_XIOS
-    IF (.NOT. debut .AND. is_omp_master) CALL xios_update_calendar(itap+1)
+! switch to XIOS LMDZ physics context 
+    IF (.NOT. debut .AND. is_omp_master) THEN
+       CALL wxios_set_context()
+       CALL xios_update_calendar(itap+1)
+    ENDIF
 #endif
 
@@ -1287,6 +1303,4 @@
        CALL strataer_init
 #endif
-
-       !!CALL flight_init
 
        print*, '================================================='
@@ -1455,5 +1469,5 @@
        tau_overturning_th(:)=0.
 
-       IF (ANY(types_trac == 'inca') .OR. ANY(types_trac == 'inco')) THEN
+       IF (ANY(type_trac == ['inca','inco'])) THEN
           ! jg : initialisation jusqu'au ces variables sont dans restart
           ccm(:,:,:) = 0.
@@ -1734,7 +1748,11 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        CALL wake_ini(rg,rd,rv,prt_level)
+       CALL yamada_ini(klon,lunout,prt_level)
+       CALL atke_ini(prt_level, lunout, RG, RD, RPI, RCPD)
        CALL thermcell_ini(iflag_thermals,prt_level,tau_thermals,lunout, &
    &    RG,RD,RCPD,RKAPPA,RLVTT,RETV)
-
+       IF (ok_new_lscp) then
+           CALL lscp_ini(pdtphys,ok_ice_sursat)
+       endif
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
@@ -2022,5 +2040,5 @@
        !c         ENDDO
        !
-       IF (ANY(types_trac == 'inca') .OR. ANY(types_trac == 'inco')) THEN ! ModThL
+       IF (ANY(type_trac == ['inca','inco'])) THEN ! ModThL
 #ifdef INCA
           CALL VTe(VTphysiq)
@@ -2036,32 +2054,57 @@
                longitude, latitude, &
                boundslon, boundslat, &
-               dx, dy, cell_area, ind_cell_glo) 
-
-
-          CALL chemini(  pplay, &
-               nbp_lon, nbp_lat, &
-               latitude_deg, &
-               longitude_deg, &
-               presnivs, &
-               calday, &
-               klon, &
-               nqtot, &
-               nqo+nqCO2, &
-               pdtphys, &
-               annee_ref, &
-               year_cur, &
-               day_ref,  &
-               day_ini, &
-               start_time, &
-               itau_phy, &
-               date0, &
-               io_lon, &
-               io_lat, &
-               chemistry_couple, &
-               init_source, &
-               init_tauinca, &
-               init_pizinca, &
-               init_cginca, &
-               init_ccminca)
+               cell_area, ind_cell_glo) 
+
+          if (grid_type==unstructured) THEN 
+             CALL chemini(  pplay, &
+                  nbp_lon, nbp_lat, &
+                  latitude_deg, &
+                  longitude_deg, &
+                  presnivs, &
+                  calday, &
+                  klon, &
+                  nqtot, &
+                  nqo+nqCO2, &
+                  pdtphys, &
+                  annee_ref, &
+                  year_cur, &
+                  day_ref,  &
+                  day_ini, &
+                  start_time, &
+                  itau_phy, &
+                  date0, &
+                  chemistry_couple, &
+                  init_source, &
+                  init_tauinca, &
+                  init_pizinca, &
+                  init_cginca, &
+                  init_ccminca)
+          ELSE
+             CALL chemini(  pplay, &
+                  nbp_lon, nbp_lat, &
+                  latitude_deg, &
+                  longitude_deg, &
+                  presnivs, &
+                  calday, &
+                  klon, &
+                  nqtot, &
+                  nqo+nqCO2, &
+                  pdtphys, &
+                  annee_ref, &
+                  year_cur, &
+                  day_ref,  &
+                  day_ini, &
+                  start_time, &
+                  itau_phy, &
+                  date0, &
+                  chemistry_couple, &
+                  init_source, &
+                  init_tauinca, &
+                  init_pizinca, &
+                  init_cginca, &
+                  init_ccminca, &
+                  io_lon, &
+                  io_lat)
+          ENDIF
 
 
@@ -2079,5 +2122,5 @@
        ENDIF
        !
-       IF (ANY(types_trac == 'repr')) THEN
+       IF (type_trac == 'repr') THEN
 #ifdef REPROBUS
           CALL chemini_rep(  &
@@ -2192,5 +2235,5 @@
 
     ! Update time and other variables in Reprobus
-    IF (ANY(types_trac == 'repr')) THEN
+    IF (type_trac == 'repr') THEN
 #ifdef REPROBUS
        CALL Init_chem_rep_xjour(jD_cur-jD_ref+day_ref)
@@ -2983,5 +3026,5 @@
           !
           !>jyg
-          IF (ANY(types_trac == 'repr')) THEN
+          IF (type_trac == 'repr') THEN
              nbtr_tmp=ntra
           ELSE
@@ -3596,13 +3639,14 @@
     ENDIF
 
-    CALL lscp(phys_tstep,missing_val,paprs,pplay, &
+    CALL lscp(klon,klev,phys_tstep,missing_val,paprs,pplay, &
          t_seri, q_seri,ptconv,ratqs, &
-         d_t_lsc, d_q_lsc, d_ql_lsc, d_qi_lsc, rneb, rneb_seri, & 
-         cldliq, picefra, rain_lsc, snow_lsc, &
-         pfrac_impa, pfrac_nucl, pfrac_1nucl, &
+         d_t_lsc, d_q_lsc, d_ql_lsc, d_qi_lsc, rneb, rneblsvol, rneb_seri, & 
+         radocond, picefra, rain_lsc, snow_lsc, &
          frac_impa, frac_nucl, beta_prec_fisrt, &
          prfl, psfl, rhcl,  &
          zqasc, fraca,ztv,zpspsk,ztla,zthl,iflag_cld_th, &
-         iflag_ice_thermo, ok_ice_sursat)
+         iflag_ice_thermo, ok_ice_sursat, zqsatl, zqsats, &
+         qclr, qcld, qss, qvc, rnebclr, rnebss, gamma_ss, &
+         Tcontr, qcontr, qcontr2, fcontrN, fcontrP )
 
     ELSE
@@ -3610,5 +3654,5 @@
     CALL fisrtilp(phys_tstep,paprs,pplay, &
          t_seri, q_seri,ptconv,ratqs, &
-         d_t_lsc, d_q_lsc, d_ql_lsc, d_qi_lsc, rneb, cldliq, &
+         d_t_lsc, d_q_lsc, d_ql_lsc, d_qi_lsc, rneb, radocond, &
          rain_lsc, snow_lsc, &
          pfrac_impa, pfrac_nucl, pfrac_1nucl, &
@@ -3657,5 +3701,5 @@
           cldfra(i,k) = rneb(i,k)
           !CR: a quoi ca sert? Faut-il ajouter qs_seri?
-          IF (.NOT.new_oliq) cldliq(i,k) = ql_seri(i,k)
+          IF (.NOT.new_oliq) radocond(i,k) = ql_seri(i,k)
        ENDDO
     ENDDO
@@ -3721,5 +3765,5 @@
           DO i = 1, klon
              IF (diafra(i,k).GT.cldfra(i,k)) THEN
-                cldliq(i,k) = dialiq(i,k)
+                radocond(i,k) = dialiq(i,k)
                 cldfra(i,k) = diafra(i,k)
              ENDIF
@@ -3758,9 +3802,9 @@
                 DO i=1,klon
                    IF (ptconv(i,k).AND.ptconvth(i,k)) THEN
-                      cldliq(i,k)=cldliq(i,k)+rnebcon(i,k)*clwcon(i,k)
+                      radocond(i,k)=radocond(i,k)+rnebcon(i,k)*clwcon(i,k)
                       cldfra(i,k)=min(cldfra(i,k)+rnebcon(i,k),1.)
                    ELSE IF (ptconv(i,k)) THEN
                       cldfra(i,k)=rnebcon(i,k)
-                      cldliq(i,k)=rnebcon(i,k)*clwcon(i,k)
+                      radocond(i,k)=rnebcon(i,k)*clwcon(i,k)
                    ENDIF
                 ENDDO
@@ -3771,5 +3815,5 @@
                 DO i=1,klon
                    cldfra(i,k)=min(cldfra(i,k)+rnebcon(i,k),1.)
-                   cldliq(i,k)=cldliq(i,k)+rnebcon(i,k)*clwcon(i,k)
+                   radocond(i,k)=radocond(i,k)+rnebcon(i,k)*clwcon(i,k)
                 ENDDO
              ENDDO
@@ -3789,5 +3833,5 @@
                    IF (ptconv(i,k).AND. .NOT.ptconvth(i,k)) THEN
                       cldfra(i,k)=rnebcon(i,k)
-                      cldliq(i,k)=rnebcon(i,k)*clwcon(i,k)
+                      radocond(i,k)=rnebcon(i,k)*clwcon(i,k)
                    ENDIF
                 ENDDO
@@ -3800,5 +3844,5 @@
           ! Ancienne version
           cldfra(:,:)=min(max(cldfra(:,:),rnebcon(:,:)),1.)
-          cldliq(:,:)=cldliq(:,:)+rnebcon(:,:)*clwcon(:,:)
+          radocond(:,:)=radocond(:,:)+rnebcon(:,:)*clwcon(:,:)
        ENDIF
 
@@ -3820,5 +3864,5 @@
           DO i = 1, klon
              IF (diafra(i,k).GT.cldfra(i,k)) THEN
-                cldliq(i,k) = dialiq(i,k)
+                radocond(i,k) = dialiq(i,k)
                 cldfra(i,k) = diafra(i,k)
              ENDIF
@@ -3888,5 +3932,5 @@
     ENDDO
 
-    IF (ANY(types_trac == 'inca') .OR. ANY(types_trac == 'inco')) THEN ! ModThL
+    IF (ANY(type_trac == ['inca','inco'])) THEN ! ModThL
 #ifdef INCA
        CALL VTe(VTphysiq)
@@ -3944,5 +3988,5 @@
 #endif
     ENDIF !type_trac = inca or inco
-    IF (ANY(types_trac == 'repr')) THEN
+    IF (type_trac == 'repr') THEN
 #ifdef REPROBUS
     !CALL chemtime_rep(itap+itau_phy-1, date0, dtime, itap)
@@ -4143,5 +4187,5 @@
           ENDIF
           CALL newmicro (flag_aerosol, ok_cdnc, bl95_b0, bl95_b1, &
-               paprs, pplay, t_seri, cldliq, picefra, cldfra, &
+               paprs, pplay, t_seri, radocond, picefra, cldfra, &
                cldtau, cldemi, cldh, cldl, cldm, cldt, cldq, &
                flwp, fiwp, flwc, fiwc, &
@@ -4151,5 +4195,5 @@
        ELSE
           CALL nuage (paprs, pplay, &
-               t_seri, cldliq, picefra, cldfra, cldtau, cldemi, &
+               t_seri, radocond, picefra, cldfra, cldtau, cldemi, &
                cldh, cldl, cldm, cldt, cldq, &
                ok_aie, &
@@ -4287,7 +4331,5 @@
           ! 
           !--interactive CO2 in ppm from carbon cycle
-          IF (carbon_cycle_rad.AND..NOT.debut) THEN
-            RCO2=RCO2_glo
-          ENDIF
+          IF (carbon_cycle_rad) RCO2=RCO2_glo
           !
           IF (prt_level .GE.10) THEN
@@ -4345,16 +4387,4 @@
  
 #ifndef CPP_XIOS
-          !--OB 30/05/2016 modified 21/10/2016
-          !--here we return swaero_diag and dryaod_diag to FALSE
-          !--and histdef will switch it back to TRUE if necessary
-          !--this is necessary to get the right swaero at first step
-          !--but only in the case of no XIOS as XIOS is covered elsewhere 
-          IF (debut) swaerofree_diag = .FALSE.
-          IF (debut) swaero_diag = .FALSE.
-          IF (debut) dryaod_diag = .FALSE.
-          !--IM 15/09/2017 here we return ok_4xCO2atm to FALSE
-          !--as for swaero_diag, see above
-          IF (debut) ok_4xCO2atm = .FALSE.
-
           !
           !IM 2eme calcul radiatif pour le cas perturbe ou au moins un
@@ -4516,6 +4546,11 @@
        DO i=1,klon
           itest(i)=0
-          !        IF ((zstd(i).gt.10.0)) THEN
-          IF (((zpic(i)-zmea(i)).GT.100.).AND.(zstd(i).GT.10.0)) THEN
+          zrel_oro(i)=zstd(i)/(max(zsig(i),1.E-8)*sqrt(cell_area(i)))
+          !zrel_oro: relative mountain height wrt relief explained by mean slope
+          ! -> condition on zrel_oro can deactivate the drag on tilted planar terrains
+          !    such as ice sheets (work by V. Wiener)
+          ! zpmm_orodr_t and zstd_orodr_t are activation thresholds set by F. Lott to
+          ! earn computation time but they are not physical.
+          IF (((zpic(i)-zmea(i)).GT.zpmm_orodr_t).AND.(zstd(i).GT.zstd_orodr_t).AND.(zrel_oro(i).LE.zrel_oro_t)) THEN
              itest(i)=1
              igwd=igwd+1
@@ -4566,5 +4601,9 @@
        DO i=1,klon
           itest(i)=0
-          IF ((zpic(i)-zmea(i)).GT.100.) THEN
+          !zrel_oro: relative mountain height wrt relief explained by mean slope
+          ! -> condition on zrel_oro can deactivate the lifting on tilted planar terrains
+          !    such as ice sheets (work by V. Wiener)
+          zrel_oro(i)=zstd(i)/(max(zsig(i),1.E-8)*sqrt(cell_area(i)))
+          IF (((zpic(i)-zmea(i)).GT.zpmm_orolf_t).AND.(zrel_oro(i).LE.zrel_oro_t)) THEN
              itest(i)=1
              igwd=igwd+1
@@ -4756,5 +4795,5 @@
 ! car on peut s'attendre a ce que les petites echelles produisent aussi de la TKE
 ! Mais attention, cela ne va pas dans le sens de la conservation de l'energie! 
-          IF (zstd(i).GT.1.0) THEN
+          IF ((zstd(i).GT.1.0) .AND.(zrel_oro(i).LE.zrel_oro_t)) THEN
              itest(i)=1
              igwd=igwd+1
@@ -4768,5 +4807,5 @@
        DO i=1,klon
           itest(i)=0
-        IF (((zpic(i)-zmea(i)).GT.100.).AND.(zstd(i).GT.10.0)) THEN
+        IF (((zpic(i)-zmea(i)).GT.zpmm_orodr_t).AND.(zstd(i).GT.zstd_orodr_t).AND.(zrel_oro(i).LE.zrel_oro_t)) THEN
              itest(i)=1
              igwd=igwd+1
@@ -4935,5 +4974,5 @@
     !
 
-    IF (ANY(types_trac=='repr')) THEN
+    IF (type_trac == 'repr') THEN
 !MM pas d'impact, car on recupere q_seri,tr_seri,t_seri via phys_local_var_mod
 !MM                               dans Reprobus
@@ -4985,5 +5024,5 @@
          presnivs, pphis,     pphi,     albsol1, &
          sh_in,   ch_in,    rhcl,      cldfra,   rneb, &
-         diafra,   cldliq,    itop_con, ibas_con, &
+         diafra,   radocond,    itop_con, ibas_con, &
          pmflxr,   pmflxs,    prfl,     psfl, &
          da,       phi,       mp,       upwd, &
@@ -5033,17 +5072,16 @@
     ! Calculer le transport de l'eau et de l'energie (diagnostique)
     !
-    CALL transp (paprs,zxtsol, &
-         t_seri, q_seri, ql_seri, qs_seri, u_seri, v_seri, zphi, &
-         ve, vq, ue, uq, vwat, uwat)
+    CALL transp (paprs,zxtsol, t_seri, q_seri, ql_seri, qs_seri, u_seri, v_seri, zphi, &
+                 ue, ve, uq, vq, uwat, vwat)
     !
     !IM global posePB BEG
     IF(1.EQ.0) THEN
        !
-       CALL transp_lay (paprs,zxtsol, &
-            t_seri, q_seri, u_seri, v_seri, zphi, &
+       CALL transp_lay (paprs,zxtsol, t_seri, q_seri, u_seri, v_seri, zphi, &
             ve_lay, vq_lay, ue_lay, uq_lay)
        !
     ENDIF !(1.EQ.0) THEN
     !IM global posePB END
+    !
     ! Accumuler les variables a stocker dans les fichiers histoire:
     !
@@ -5056,5 +5094,5 @@
     d_t_ec(:,:)=0.
     forall (k=1: nbp_lev) exner(:, k) = (pplay(:, k)/paprs(:,1))**RKAPPA
-    CALL ener_conserv(klon,klev,pdtphys,u,v,t,qx(:,:,ivap),qx(:,:,iliq),qx(:,:,isol), &
+    CALL ener_conserv(klon,klev,pdtphys,u,v,t,qx,ivap,iliq,isol, &
          u_seri,v_seri,t_seri,q_seri,ql_seri,qs_seri,pbl_tke(:,:,is_ave)-tke0(:,:), &
          zmasse,exner,d_t_ec)
@@ -5089,5 +5127,5 @@
     ENDDO
     !
-    IF (ANY(types_trac == 'inca') .OR. ANY(types_trac == 'inco')) THEN
+    IF (ANY(type_trac == ['inca','inco'])) THEN
 #ifdef INCA
        CALL VTe(VTphysiq)
@@ -5113,5 +5151,5 @@
     ENDIF
 
-    IF (ANY(types_trac == 'repr')) THEN
+    IF (type_trac == 'repr') THEN
 #ifdef REPROBUS
         CALL coord_hyb_rep(paprs, pplay, aps, bps, ap, bp, cell_area)
@@ -5151,16 +5189,15 @@
     ENDDO
     !
-    IF (nqtot > nqo) THEN
-       itr = 0
-       DO iq = 1, nqtot
-          IF(.NOT.tracers(iq)%isInPhysics) CYCLE
-          itr = itr+1
-          DO  k = 1, klev
-             DO  i = 1, klon
-                d_qx(i,k,iq) = ( tr_seri(i,k,itr) - qx(i,k,iq) ) / phys_tstep
-             ENDDO
+    ! DC: All iterations are cycled if nqtot==nqo, so no nqtot>nqo condition required
+    itr = 0
+    DO iq = 1, nqtot
+       IF(.NOT.tracers(iq)%isInPhysics) CYCLE
+       itr = itr+1
+       DO  k = 1, klev
+          DO  i = 1, klon
+             d_qx(i,k,iq) = ( tr_seri(i,k,itr) - qx(i,k,iq) ) / phys_tstep
           ENDDO
        ENDDO
-    ENDIF
+    ENDDO
     !
     !IM rajout diagnostiques bilan KP pour analyse MJO par Jun-Ichi Yano
@@ -5375,5 +5412,5 @@
 
 #ifdef INCA
-       if (ANY(types_trac == 'inca' )) then 
+       if (type_trac == 'inca') then 
           IF (is_omp_master .and. grid_type==unstructured) THEN 
              CALL finalize_inca
